package com.zt.plat.module.qms.business.config.dal.mapper;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.framework.mybatis.core.query.MPJLambdaWrapperX;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigAssayMethodProjectPageReqVO;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodDO;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectDO;
import com.zt.plat.module.qms.business.dic.dal.dataobject.DictionaryProjectDO;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;

/**
 * 检测方法分析项目配置 Mapper
 *
 * @author 后台管理
 */
@Mapper
public interface ConfigAssayMethodProjectMapper extends BaseMapperX<ConfigAssayMethodProjectDO> {

    default PageResult<ConfigAssayMethodProjectDO> selectPage(ConfigAssayMethodProjectPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<ConfigAssayMethodProjectDO>()
                .eqIfPresent(ConfigAssayMethodProjectDO::getConfigAssayMethodId, reqVO.getConfigAssayMethodId())
                .eqIfPresent(ConfigAssayMethodProjectDO::getDictionaryProjectId, reqVO.getDictionaryProjectId())
                .eqIfPresent(ConfigAssayMethodProjectDO::getUnitId, reqVO.getUnitId())
                .eqIfPresent(ConfigAssayMethodProjectDO::getDictionaryProjectUnit, reqVO.getDictionaryProjectUnit())
                .eqIfPresent(ConfigAssayMethodProjectDO::getIsNull, reqVO.getIsNull())
                .eqIfPresent(ConfigAssayMethodProjectDO::getDataType, reqVO.getDataType())
                .eqIfPresent(ConfigAssayMethodProjectDO::getDecimalPosition, reqVO.getDecimalPosition())
                .eqIfPresent(ConfigAssayMethodProjectDO::getEffectiveDigit, reqVO.getEffectiveDigit())
                .eqIfPresent(ConfigAssayMethodProjectDO::getFormula, reqVO.getFormula())
                .eqIfPresent(ConfigAssayMethodProjectDO::getAssessmentAccuracy, reqVO.getAssessmentAccuracy())
                .eqIfPresent(ConfigAssayMethodProjectDO::getIsDefaultEnabled, reqVO.getIsDefaultEnabled())
                .eqIfPresent(ConfigAssayMethodProjectDO::getMinimumLimitValue, reqVO.getMinimumLimitValue())
                .eqIfPresent(ConfigAssayMethodProjectDO::getSortNo, reqVO.getSortNo())
                .eqIfPresent(ConfigAssayMethodProjectDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(ConfigAssayMethodProjectDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(ConfigAssayMethodProjectDO::getRemark, reqVO.getRemark())
                .eqIfPresent(ConfigAssayMethodProjectDO::getVersion, reqVO.getVersion())
                .orderByDesc(ConfigAssayMethodProjectDO::getId));
    }

	default List<ConfigAssayMethodProjectExtendRespVO> selectByConfigAssayMethodId(Long configAssayMethodId) {
		return selectJoinList(ConfigAssayMethodProjectExtendRespVO.class, new MPJLambdaWrapperX<ConfigAssayMethodProjectDO>()
				.leftJoin(DictionaryProjectDO.class, DictionaryProjectDO::getId, ConfigAssayMethodProjectDO::getDictionaryProjectId)
				.selectAll(ConfigAssayMethodProjectDO.class)
				.selectAs(DictionaryProjectDO::getKey, ConfigAssayMethodProjectExtendRespVO::getDictionaryProjectKey)
				.selectAs(DictionaryProjectDO::getSimpleName, ConfigAssayMethodProjectExtendRespVO::getSimpleName)
				.selectAs(DictionaryProjectDO::getShowName, ConfigAssayMethodProjectExtendRespVO::getShowName)
				.eq(ConfigAssayMethodProjectDO::getConfigAssayMethodId, configAssayMethodId));
	}

	default List<ConfigAssayMethodProjectExtendRespVO> selectByConfigAssayMethodIds(List<Long> configAssayMethodIds) {
		return selectJoinList(ConfigAssayMethodProjectExtendRespVO.class, new MPJLambdaWrapperX<ConfigAssayMethodProjectDO>()
				.leftJoin(DictionaryProjectDO.class, DictionaryProjectDO::getId, ConfigAssayMethodProjectDO::getDictionaryProjectId)
				.selectAll(ConfigAssayMethodProjectDO.class)
				.selectAs(DictionaryProjectDO::getKey, ConfigAssayMethodProjectExtendRespVO::getDictionaryProjectKey)
				.selectAs(DictionaryProjectDO::getSimpleName, ConfigAssayMethodProjectExtendRespVO::getSimpleName)
				.selectAs(DictionaryProjectDO::getShowName, ConfigAssayMethodProjectExtendRespVO::getShowName)
				.in(ConfigAssayMethodProjectDO::getConfigAssayMethodId, configAssayMethodIds));
	}
	
	/**
	 * 根据子样配置及分析部门查询检测项目
	 * @param configSubSampleIds 子样配置
	 * @param assayDepartmentId 分析部门
	 * @return
	 */
	default List<ConfigAssayMethodProjectExtendRespVO> selectByConfigSubSampleIdsAndAssayDepartmentId(List<Long> configSubSampleIds, Long assayDepartmentId) {
		StringBuilder inSql = new StringBuilder("SELECT	tcsspm.CFG_ASY_MTHD_ID FROM T_CFG_SB_SMP_MTHD tcssm LEFT JOIN T_CFG_SB_SMP_PRN_MTHD tcsspm ON tcssm.CFG_SB_SMP_PRN_MTHD_ID = tcsspm.ID WHERE tcssm.DELETED = 0 AND tcsspm.DELETED = 0 AND tcssm.CFG_SB_SMP_ID IN (");
		for (Long configSubSampleId : configSubSampleIds) {
			inSql.append(configSubSampleId).append(",");
		}
		inSql.delete(inSql.length() - 1, inSql.length());
		inSql.append(")");
		return selectJoinList(ConfigAssayMethodProjectExtendRespVO.class, new MPJLambdaWrapperX<ConfigAssayMethodProjectDO>()
				.leftJoin(ConfigAssayMethodDO.class, ConfigAssayMethodDO::getId, ConfigAssayMethodProjectDO::getConfigAssayMethodId)
				.selectAll(ConfigAssayMethodProjectDO.class)
				.selectAs(ConfigAssayMethodDO::getName, ConfigAssayMethodProjectExtendRespVO::getConfigAssayMethodName)
				.selectAs(ConfigAssayMethodDO::getMethodNameCategory, ConfigAssayMethodProjectExtendRespVO::getConfigAssayMethodNameAndCategory)
				.eq(ConfigAssayMethodDO::getAssayDepartmentId, assayDepartmentId)
				.inSql(ConfigAssayMethodProjectDO::getConfigAssayMethodId, inSql.toString()));
	}
	
	/**
	 * 根据分析部门查询检测项目
	 * @param assayDepartmentId 分析部门
	 * @return
	 */
	default List<ConfigAssayMethodProjectExtendRespVO> selectByAssayDepartmentId(Long assayDepartmentId) {
		return selectJoinList(ConfigAssayMethodProjectExtendRespVO.class, new MPJLambdaWrapperX<ConfigAssayMethodProjectDO>()
				.leftJoin(ConfigAssayMethodDO.class, ConfigAssayMethodDO::getId, ConfigAssayMethodProjectDO::getConfigAssayMethodId)
				.leftJoin(DictionaryProjectDO.class, DictionaryProjectDO::getId, ConfigAssayMethodProjectDO::getDictionaryProjectId)
				.selectAll(ConfigAssayMethodProjectDO.class)
				.selectAs(ConfigAssayMethodDO::getName, ConfigAssayMethodProjectExtendRespVO::getConfigAssayMethodName)
				.selectAs(ConfigAssayMethodDO::getMethodNameCategory, ConfigAssayMethodProjectExtendRespVO::getConfigAssayMethodNameAndCategory)
				.selectAs(DictionaryProjectDO::getKey, ConfigAssayMethodProjectExtendRespVO::getDictionaryProjectKey)
				.selectAs(DictionaryProjectDO::getSimpleName, ConfigAssayMethodProjectExtendRespVO::getSimpleName)
				.selectAs(DictionaryProjectDO::getShowName, ConfigAssayMethodProjectExtendRespVO::getShowName)
				.eq(ConfigAssayMethodDO::getAssayDepartmentId, assayDepartmentId));
	}

}